/*
 * Copyright (c) 2002, 2003 MATPOCKuH.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _MQUEUE_H_
#define _MQUEUE_H_

typedef struct mq_record_s {
    struct mq_record_s *next;
    struct mq_record_s *prev;
} mq_record_t;

typedef struct {
    mq_record_t *head;
    mq_record_t *tail;
    mq_record_t *cur;
    mq_record_t *next;
    size_t rsize;
} mq_queue_t;

extern mq_queue_t * mq_makequeue(size_t);
extern void mq_addrecord(mq_queue_t *, mq_record_t *);
extern mq_record_t * mq_addnewrecord(mq_queue_t *);
extern mq_record_t * mq_resetcurrent(mq_queue_t *);
extern mq_record_t * mq_getcurrent(mq_queue_t *);
extern mq_record_t * mq_gethead(mq_queue_t *);
extern mq_record_t * mq_gettail(mq_queue_t *);
extern mq_record_t * mq_nextrecord(mq_queue_t *);
extern mq_record_t * mq_removecurrent(mq_queue_t *);

#endif
